<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Scan".
 *
 * Columns in table "scan" available as properties of the model,
 * followed by relations of table "scan" available as properties of the model.
 *
 * @property integer $id
 * @property integer $organization_id
 * @property integer $provider_id
 * @property integer $practice_id
 * @property integer $google_places_optimized
 * @property integer $yelp_claimed
 * @property integer $completed_scans
 * @property integer $data_elements
 * @property integer $data_element_errors
 * @property integer $missing_listings
 * @property integer $review_tally
 * @property integer $pagespeed_score
 * @property integer $listing_accuracy
 * @property integer $overall_score
 * @property string $reviews_average
 * @property string $reviews_grade
 * @property string $zip
 * @property string $trigger
 * @property string $specialty_field
 * @property string $year_month
 * @property string $provider_name
 * @property string $practice_name
 * @property string $address
 * @property string $phone
 * @property string $website
 * @property string $date_added
 *
 * @property Organization $organization
 * @property Provider $provider
 * @property Practice $practice
 * @property ScanResult[] $scanResults
 */
abstract class BaseScan extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Scan|Scans', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('organization_id, practice_id', 'required'),
            array('organization_id, provider_id, practice_id, google_places_optimized, yelp_claimed, completed_scans, data_elements, data_element_errors, missing_listings, review_tally, pagespeed_score, listing_accuracy, overall_score', 'numerical', 'integerOnly' => true),
            array('reviews_average, reviews_grade', 'length', 'max' => 3),
            array('zip', 'length', 'max' => 5),
            array('trigger, specialty_field', 'length', 'max' => 1),
            array('year_month', 'length', 'max' => 7),
            array('provider_name, practice_name, address, website', 'length', 'max' => 255),
            array('phone', 'length', 'max' => 32),
            array('date_added', 'safe'),
            array('google_places_optimized, yelp_claimed, completed_scans, data_elements, data_element_errors, missing_listings, review_tally, pagespeed_score, listing_accuracy, overall_score, reviews_average, reviews_grade, zip, trigger, specialty_field, year_month, provider_name, practice_name, address, phone, website, date_added', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, organization_id, provider_id, practice_id, google_places_optimized, yelp_claimed, completed_scans, data_elements, data_element_errors, missing_listings, review_tally, pagespeed_score, listing_accuracy, overall_score, reviews_average, reviews_grade, zip, trigger, specialty_field, year_month, provider_name, practice_name, address, phone, website, date_added', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'organization' => array(self::BELONGS_TO, 'Organization', 'organization_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'scanResults' => array(self::HAS_MANY, 'ScanResult', 'scan_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'organization_id' => null,
            'provider_id' => null,
            'practice_id' => null,
            'google_places_optimized' => Yii::t('app', 'Google Places Optimized'),
            'yelp_claimed' => Yii::t('app', 'Yelp Claimed'),
            'completed_scans' => Yii::t('app', 'Completed Scans'),
            'data_elements' => Yii::t('app', 'Data Elements'),
            'data_element_errors' => Yii::t('app', 'Data Element Errors'),
            'missing_listings' => Yii::t('app', 'Missing Listings'),
            'review_tally' => Yii::t('app', 'Review Tally'),
            'pagespeed_score' => Yii::t('app', 'Pagespeed Score'),
            'listing_accuracy' => Yii::t('app', 'Listing Accuracy'),
            'overall_score' => Yii::t('app', 'Overall Score'),
            'reviews_average' => Yii::t('app', 'Reviews Average'),
            'reviews_grade' => Yii::t('app', 'Reviews Grade'),
            'zip' => Yii::t('app', 'Zip'),
            'trigger' => Yii::t('app', 'Trigger'),
            'specialty_field' => Yii::t('app', 'Specialty Field'),
            'year_month' => Yii::t('app', 'Year Month'),
            'provider_name' => Yii::t('app', 'Provider Name'),
            'practice_name' => Yii::t('app', 'Practice Name'),
            'address' => Yii::t('app', 'Address'),
            'phone' => Yii::t('app', 'Phone'),
            'website' => Yii::t('app', 'Website'),
            'date_added' => Yii::t('app', 'Date Added'),
            'organization' => null,
            'provider' => null,
            'practice' => null,
            'scanResults' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('organization_id', $this->organization_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('google_places_optimized', $this->google_places_optimized);
        $criteria->compare('yelp_claimed', $this->yelp_claimed);
        $criteria->compare('completed_scans', $this->completed_scans);
        $criteria->compare('data_elements', $this->data_elements);
        $criteria->compare('data_element_errors', $this->data_element_errors);
        $criteria->compare('missing_listings', $this->missing_listings);
        $criteria->compare('review_tally', $this->review_tally);
        $criteria->compare('pagespeed_score', $this->pagespeed_score);
        $criteria->compare('listing_accuracy', $this->listing_accuracy);
        $criteria->compare('overall_score', $this->overall_score);
        $criteria->compare('reviews_average', $this->reviews_average, true);
        $criteria->compare('reviews_grade', $this->reviews_grade, true);
        $criteria->compare('zip', $this->zip, true);
        $criteria->compare('trigger', $this->trigger, true);
        $criteria->compare('specialty_field', $this->specialty_field, true);
        $criteria->compare('year_month', $this->year_month, true);
        $criteria->compare('provider_name', $this->provider_name, true);
        $criteria->compare('practice_name', $this->practice_name, true);
        $criteria->compare('address', $this->address, true);
        $criteria->compare('phone', $this->phone, true);
        $criteria->compare('website', $this->website, true);
        $criteria->compare('date_added', $this->date_added, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
